#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "util.h"
#include "ranlib.h"
#include "header.h"

int main(int argc, char *argv[]){
  int t,u,p,points;
  long seed1, seed2;
  double vih;

  phrtsd("Get Rich Quick!",&seed1, &seed2);
  setall(seed1, seed2);
  
  for(u=0;u<UNDERLIERS;++u){
    Price[0][u][0] = INITIAL;
    Prob[0][u][0] = 1.0/UNDERLIERS;
  }

  Max1[0][0] = 0;
  Max2[0][0] = 1;

  if(INITIAL>STRIKE){
    Value_if_exercised[0][0] - INITIAL-STRIKE;
  }else{
    Value_if_exercised[0][0] = 0;
  }

  /* Fill Price[][][], Max1[][], Max2[][], Value_if_exercised[][] */
  for(t=1;t<TIMESLICES;++t){
    init_rng(t);
    points = points_on_timeslice(t);
    for(p=0;p<points;++p){
      generate_point(t,p);
    }
  }

  for(t=0;t<TIMESLICES;++t){
    points=points_on_timeslice(t);
    for(p=0;p<points;++p){
      printf("%i\t",Max1[t][p]);
    }
    printf("\n");
  }


  /* Fill Prob[][][] */
  for(t=1;t<TIMESLICES;++t){
    points = points_on_timeslice(t);
    for(p=0;p<points;++p){
      prob_of_max(t,p);
    }
  }

  for(t=0;t<TIMESLICES;++t){
    points = points_on_timeslice(t);
    for(p=0;p<points;++p){
      printf("%f\t",Prob[t][p]);
    }
    printf("\n");
  }

  
  /* Fill Value[][] */
  for(t=TIMESLICES-1;t>0;--t){
    points = points_on_timeslice(t);
    for(p=0;p<points;++p){
      vih = mesh_estimate_3(t,p);
      if(vih > Value_if_exercised[t][p]){
	Value[t][p] = vih;
      }else{
	Value[t][p] = Value_if_exercised[t][p];
      }
    }
  }
  vih = mesh_estimate_3(t,p);
  
  if(vih > Value_if_exercised[t][p]){
    Value[0][0] = vih;
  }else{
    Value[0][0] = Value_if_exercised[t][p];
  }

  printf("Value = %lf\n",Value[0][0]);
  exit(0);
}

int points_on_timeslice(int t){
  int c;

  c = (POINTS-MINPOINTS)/pow(EXPIRATION,POWER);
  return(MINPOINTS + c*pow(EXPIRATION*(double)t/(TIMESLICES-1),POWER));
}

 
